<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">SDL.GPU.Simple.Conversions</span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-2"></span><span>
</span><span id="line-3"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.Word</span></span><span>
</span><span id="line-4"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Ptr</span></span><span>
</span><span id="line-5"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Control.Monad.IO.Class</span></span><span>
</span><span id="line-6"></span><span>
</span><span id="line-7"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">SDL.Raw.Types</span></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">SDL.Raw</span></span><span>
</span><span id="line-8"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">SDL</span></span><span>
</span><span id="line-9"></span><span>
</span><span id="line-10"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.C.html"><span class="hs-identifier">SDL.GPU.C</span></a></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">GPU</span></span><span>
</span><span id="line-11"></span><span>
</span><span id="line-12"></span><span class="annot"><a href="SDL.GPU.Simple.Conversions.html#copyImageFromRawSurface"><span class="hs-identifier hs-type">copyImageFromRawSurface</span></a></span><span>
</span><span id="line-13"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190029"><span class="annot"><a href="#local-6989586621679190029"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-14"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190029"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-15"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><span class="hs-identifier hs-type">SDL.Raw.Surface</span></span><span>
</span><span id="line-16"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190029"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-17"></span><span id="copyImageFromRawSurface"><span class="annot"><span class="annottext">copyImageFromRawSurface :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Surface -&gt; m (Ptr Image)
</span><a href="SDL.GPU.Simple.Conversions.html#copyImageFromRawSurface"><span class="hs-identifier hs-var hs-var">copyImageFromRawSurface</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Surface -&gt; IO (Ptr Image)
</span><a href="SDL.GPU.C.Conversions.html#copyImageFromSurface"><span class="hs-identifier hs-var">GPU.copyImageFromSurface</span></a></span><span>
</span><span id="line-18"></span><span>
</span><span id="line-19"></span><span class="annot"><a href="SDL.GPU.Simple.Conversions.html#copyImageFromSurface"><span class="hs-identifier hs-type">copyImageFromSurface</span></a></span><span>
</span><span id="line-20"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190019"><span class="annot"><a href="#local-6989586621679190019"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-21"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190019"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-22"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">SDL.Surface</span></span><span>
</span><span id="line-23"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190019"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-24"></span><span id="copyImageFromSurface"><span class="annot"><span class="annottext">copyImageFromSurface :: forall (m :: * -&gt; *). MonadIO m =&gt; Surface -&gt; m (Ptr Image)
</span><a href="SDL.GPU.Simple.Conversions.html#copyImageFromSurface"><span class="hs-identifier hs-var hs-var">copyImageFromSurface</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">SDL.Surface</span></span><span> </span><span id="local-6989586621679189982"><span class="annot"><span class="annottext">Ptr Surface
</span><a href="#local-6989586621679189982"><span class="hs-identifier hs-var">ptr</span></a></span></span><span> </span><span class="annot"><span class="annottext">Maybe (IOVector Word8)
</span><span class="hs-identifier">_</span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Surface -&gt; IO (Ptr Image)
</span><a href="SDL.GPU.C.Conversions.html#copyImageFromSurface"><span class="hs-identifier hs-var">GPU.copyImageFromSurface</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Surface
</span><a href="#local-6989586621679189982"><span class="hs-identifier hs-var">ptr</span></a></span><span>
</span><span id="line-25"></span><span>
</span><span id="line-26"></span><span class="annot"><a href="SDL.GPU.Simple.Conversions.html#copyImageFromTarget"><span class="hs-identifier hs-type">copyImageFromTarget</span></a></span><span>
</span><span id="line-27"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190012"><span class="annot"><a href="#local-6989586621679190012"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-28"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190012"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-29"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-30"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190012"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-31"></span><span id="copyImageFromTarget"><span class="annot"><span class="annottext">copyImageFromTarget :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; m (Ptr Image)
</span><a href="SDL.GPU.Simple.Conversions.html#copyImageFromTarget"><span class="hs-identifier hs-var hs-var">copyImageFromTarget</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; IO (Ptr Image)
</span><a href="SDL.GPU.C.Conversions.html#copyImageFromTarget"><span class="hs-identifier hs-var">GPU.copyImageFromTarget</span></a></span><span>
</span><span id="line-32"></span><span>
</span><span id="line-33"></span><span class="annot"><a href="SDL.GPU.Simple.Conversions.html#copyRawSurfaceFromTarget"><span class="hs-identifier hs-type">copyRawSurfaceFromTarget</span></a></span><span>
</span><span id="line-34"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190009"><span class="annot"><a href="#local-6989586621679190009"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-35"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190009"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-36"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-37"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190009"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><span class="hs-identifier hs-type">SDL.Raw.Surface</span></span><span class="hs-special">)</span><span>
</span><span id="line-38"></span><span id="copyRawSurfaceFromTarget"><span class="annot"><span class="annottext">copyRawSurfaceFromTarget :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; m (Ptr Surface)
</span><a href="SDL.GPU.Simple.Conversions.html#copyRawSurfaceFromTarget"><span class="hs-identifier hs-var hs-var">copyRawSurfaceFromTarget</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; IO (Ptr Surface)
</span><a href="SDL.GPU.C.Conversions.html#copySurfaceFromTarget"><span class="hs-identifier hs-var">GPU.copySurfaceFromTarget</span></a></span><span>
</span><span id="line-39"></span><span>
</span><span id="line-40"></span><span class="annot"><a href="SDL.GPU.Simple.Conversions.html#copySurfaceFromTarget"><span class="hs-identifier hs-type">copySurfaceFromTarget</span></a></span><span>
</span><span id="line-41"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190007"><span class="annot"><a href="#local-6989586621679190007"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-42"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190007"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-43"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-44"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190007"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">SDL.Surface</span></span><span class="hs-special">)</span><span>
</span><span id="line-45"></span><span id="copySurfaceFromTarget"><span class="annot"><span class="annottext">copySurfaceFromTarget :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; m Surface
</span><a href="SDL.GPU.Simple.Conversions.html#copySurfaceFromTarget"><span class="hs-identifier hs-var hs-var">copySurfaceFromTarget</span></a></span></span><span> </span><span id="local-6989586621679189963"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679189963"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-46"></span><span>  </span><span class="annot"><span class="annottext">forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-identifier hs-var">fmap</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">forall a b c. (a -&gt; b -&gt; c) -&gt; b -&gt; a -&gt; c
</span><span class="hs-identifier hs-var">Prelude.flip</span></span><span> </span><span class="annot"><span class="annottext">Ptr Surface -&gt; Maybe (IOVector Word8) -&gt; Surface
</span><span class="hs-identifier hs-var">SDL.Surface</span></span><span> </span><span class="annot"><span class="annottext">forall a. Maybe a
</span><span class="hs-identifier hs-var">Nothing</span></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; IO (Ptr Surface)
</span><a href="SDL.GPU.C.Conversions.html#copySurfaceFromTarget"><span class="hs-identifier hs-var">GPU.copySurfaceFromTarget</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679189963"><span class="hs-identifier hs-var">t</span></a></span><span>
</span><span id="line-47"></span><span>
</span><span id="line-48"></span><span class="annot"><a href="SDL.GPU.Simple.Conversions.html#copyRawSurfaceFromImage"><span class="hs-identifier hs-type">copyRawSurfaceFromImage</span></a></span><span>
</span><span id="line-49"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679189996"><span class="annot"><a href="#local-6989586621679189996"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-50"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679189996"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-51"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-52"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679189996"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><span class="hs-identifier hs-type">SDL.Raw.Surface</span></span><span class="hs-special">)</span><span>
</span><span id="line-53"></span><span id="copyRawSurfaceFromImage"><span class="annot"><span class="annottext">copyRawSurfaceFromImage :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Image -&gt; m (Ptr Surface)
</span><a href="SDL.GPU.Simple.Conversions.html#copyRawSurfaceFromImage"><span class="hs-identifier hs-var hs-var">copyRawSurfaceFromImage</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; IO (Ptr Surface)
</span><a href="SDL.GPU.C.Conversions.html#copySurfaceFromImage"><span class="hs-identifier hs-var">GPU.copySurfaceFromImage</span></a></span><span>
</span><span id="line-54"></span><span>
</span><span id="line-55"></span><span class="annot"><a href="SDL.GPU.Simple.Conversions.html#copySurfaceFromImage"><span class="hs-identifier hs-type">copySurfaceFromImage</span></a></span><span>
</span><span id="line-56"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679189994"><span class="annot"><a href="#local-6989586621679189994"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-57"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679189994"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-58"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-59"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679189994"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">SDL.Surface</span></span><span class="hs-special">)</span><span>
</span><span id="line-60"></span><span id="copySurfaceFromImage"><span class="annot"><span class="annottext">copySurfaceFromImage :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Image -&gt; m Surface
</span><a href="SDL.GPU.Simple.Conversions.html#copySurfaceFromImage"><span class="hs-identifier hs-var hs-var">copySurfaceFromImage</span></a></span></span><span> </span><span id="local-6989586621679189950"><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679189950"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-61"></span><span>  </span><span class="annot"><span class="annottext">forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-identifier hs-var">fmap</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">forall a b c. (a -&gt; b -&gt; c) -&gt; b -&gt; a -&gt; c
</span><span class="hs-identifier hs-var">Prelude.flip</span></span><span> </span><span class="annot"><span class="annottext">Ptr Surface -&gt; Maybe (IOVector Word8) -&gt; Surface
</span><span class="hs-identifier hs-var">SDL.Surface</span></span><span> </span><span class="annot"><span class="annottext">forall a. Maybe a
</span><span class="hs-identifier hs-var">Nothing</span></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; IO (Ptr Surface)
</span><a href="SDL.GPU.C.Conversions.html#copySurfaceFromImage"><span class="hs-identifier hs-var">GPU.copySurfaceFromImage</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679189950"><span class="hs-identifier hs-var">t</span></a></span><span>
</span><span id="line-62"></span><span>
</span><span id="line-63"></span></pre></body></html>